<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.model;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.IOException;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.Arrays;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.concurrent.ArrayBlockingQueue;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.concurrent.BlockingQueue;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.concurrent.atomic.AtomicReference;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.logging.Logger;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.math.NumberOperations;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.metabolic.FluxDistribution;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.metabolic.MetabolicNetwork;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.metabolic.Reaction;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.metabolic.compress.CompressedMetabolicNetwork;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.metabolic.efm.column.Column;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.metabolic.efm.column.ColumnHome;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.metabolic.efm.config.Config;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.metabolic.efm.model.nullspace.CannotReconstructFluxException;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.metabolic.efm.output.CallbackGranularity;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.metabolic.efm.output.EfmOutputCallback;<a name="line.53"></a>
<FONT color="green">054</FONT>    import ch.javasoft.metabolic.efm.output.EfmOutputEvent;<a name="line.54"></a>
<FONT color="green">055</FONT>    import ch.javasoft.metabolic.efm.util.ColumnUtil;<a name="line.55"></a>
<FONT color="green">056</FONT>    import ch.javasoft.util.ExceptionUtil;<a name="line.56"></a>
<FONT color="green">057</FONT>    import ch.javasoft.util.genarr.ArrayIterable;<a name="line.57"></a>
<FONT color="green">058</FONT>    import ch.javasoft.util.logging.LogFragmenter;<a name="line.58"></a>
<FONT color="green">059</FONT>    <a name="line.59"></a>
<FONT color="green">060</FONT>    /**<a name="line.60"></a>
<FONT color="green">061</FONT>     * The &lt;code&gt;AbstractColumnToFluxDistributionConverter&lt;/code&gt; implements methods<a name="line.61"></a>
<FONT color="green">062</FONT>     * which are common to most implementations.<a name="line.62"></a>
<FONT color="green">063</FONT>     */<a name="line.63"></a>
<FONT color="green">064</FONT>    abstract public class AbstractColumnToFluxDistributionConverter&lt;N extends Number, Col extends Column&gt; implements ColumnToFluxDistributionConverter&lt;N, Col&gt; {<a name="line.64"></a>
<FONT color="green">065</FONT>            <a name="line.65"></a>
<FONT color="green">066</FONT>            private static final Logger LOG = LogPkg.LOGGER;<a name="line.66"></a>
<FONT color="green">067</FONT>    <a name="line.67"></a>
<FONT color="green">068</FONT>            protected final ColumnHome&lt;N, Col&gt; columnHome;<a name="line.68"></a>
<FONT color="green">069</FONT>            <a name="line.69"></a>
<FONT color="green">070</FONT>            public AbstractColumnToFluxDistributionConverter(ColumnHome&lt;N, Col&gt; columnHome) {<a name="line.70"></a>
<FONT color="green">071</FONT>                    this.columnHome = columnHome;<a name="line.71"></a>
<FONT color="green">072</FONT>            }<a name="line.72"></a>
<FONT color="green">073</FONT>            <a name="line.73"></a>
<FONT color="green">074</FONT>            private static class WorkerThread extends Thread {<a name="line.74"></a>
<FONT color="green">075</FONT>                    private final AtomicReference&lt;IOException&gt; exception;<a name="line.75"></a>
<FONT color="green">076</FONT>                    private final BlockingQueue&lt;Runnable&gt; jobs;<a name="line.76"></a>
<FONT color="green">077</FONT>                    <a name="line.77"></a>
<FONT color="green">078</FONT>                    public WorkerThread(BlockingQueue&lt;Runnable&gt; jobs, AtomicReference&lt;IOException&gt; exception) {<a name="line.78"></a>
<FONT color="green">079</FONT>                            this.jobs               = jobs;<a name="line.79"></a>
<FONT color="green">080</FONT>                            this.exception  = exception;<a name="line.80"></a>
<FONT color="green">081</FONT>                    }<a name="line.81"></a>
<FONT color="green">082</FONT>                    <a name="line.82"></a>
<FONT color="green">083</FONT>                    private volatile boolean endOfQueue = false;<a name="line.83"></a>
<FONT color="green">084</FONT>                    public void setEndOfQueue() {<a name="line.84"></a>
<FONT color="green">085</FONT>                            endOfQueue = true;<a name="line.85"></a>
<FONT color="green">086</FONT>                    }<a name="line.86"></a>
<FONT color="green">087</FONT>                    @Override<a name="line.87"></a>
<FONT color="green">088</FONT>                    public void run() {<a name="line.88"></a>
<FONT color="green">089</FONT>                            while (true) {<a name="line.89"></a>
<FONT color="green">090</FONT>                                    try {<a name="line.90"></a>
<FONT color="green">091</FONT>                                            final Runnable runnable = jobs.poll();<a name="line.91"></a>
<FONT color="green">092</FONT>                                            if (runnable == null) {<a name="line.92"></a>
<FONT color="green">093</FONT>                                                    if (endOfQueue) {<a name="line.93"></a>
<FONT color="green">094</FONT>                                                            return;<a name="line.94"></a>
<FONT color="green">095</FONT>                                                    }<a name="line.95"></a>
<FONT color="green">096</FONT>                                                    yield();<a name="line.96"></a>
<FONT color="green">097</FONT>                                            }<a name="line.97"></a>
<FONT color="green">098</FONT>                                            else {<a name="line.98"></a>
<FONT color="green">099</FONT>                                                    runnable.run();<a name="line.99"></a>
<FONT color="green">100</FONT>                                            }<a name="line.100"></a>
<FONT color="green">101</FONT>                                    }<a name="line.101"></a>
<FONT color="green">102</FONT>                                    catch (Exception e) {<a name="line.102"></a>
<FONT color="green">103</FONT>                                            exception.compareAndSet(null, ExceptionUtil.toIOException(e));<a name="line.103"></a>
<FONT color="green">104</FONT>                                    }<a name="line.104"></a>
<FONT color="green">105</FONT>                            }<a name="line.105"></a>
<FONT color="green">106</FONT>                    }<a name="line.106"></a>
<FONT color="green">107</FONT>            }<a name="line.107"></a>
<FONT color="green">108</FONT>            <a name="line.108"></a>
<FONT color="green">109</FONT>        /**<a name="line.109"></a>
<FONT color="green">110</FONT>         * Writes the columns to the specified callback, including uncompression of<a name="line.110"></a>
<FONT color="green">111</FONT>         * flux modes and appending of external-to-external modes. The method uses<a name="line.111"></a>
<FONT color="green">112</FONT>         * multiple threads to perform this operation.<a name="line.112"></a>
<FONT color="green">113</FONT>         */<a name="line.113"></a>
<FONT color="green">114</FONT>            public void writeColumnsToCallback(final Config config, final NetworkEfmModel model, final Iterable&lt;Col&gt; columns, final EfmOutputCallback callback) throws IOException {<a name="line.114"></a>
<FONT color="green">115</FONT>                    final long efmCount = writeE2eReactionsToCallback(config, model, columns, callback);<a name="line.115"></a>
<FONT color="green">116</FONT>    <a name="line.116"></a>
<FONT color="green">117</FONT>                    int logcnt = 1000;<a name="line.117"></a>
<FONT color="green">118</FONT>                    final int offset = (int)(efmCount - ColumnUtil.getColumnCount(columns));<a name="line.118"></a>
<FONT color="green">119</FONT>                    final LogFragmenter log;<a name="line.119"></a>
<FONT color="green">120</FONT>                    if (callback.allowLoggingDuringOutput()) {<a name="line.120"></a>
<FONT color="green">121</FONT>                            log = new LogFragmenter(LOG);<a name="line.121"></a>
<FONT color="green">122</FONT>                            log.fineStart("uncompressing efms: ");<a name="line.122"></a>
<FONT color="green">123</FONT>                    }<a name="line.123"></a>
<FONT color="green">124</FONT>                    else {<a name="line.124"></a>
<FONT color="green">125</FONT>                            log = null;<a name="line.125"></a>
<FONT color="green">126</FONT>                    }<a name="line.126"></a>
<FONT color="green">127</FONT>                    final AtomicReference&lt;IOException&gt; exception = new AtomicReference&lt;IOException&gt;(); <a name="line.127"></a>
<FONT color="green">128</FONT>                    final int threadCnt = Math.min(Runtime.getRuntime().availableProcessors(), config.getMaxThreads());<a name="line.128"></a>
<FONT color="green">129</FONT>                    final BlockingQueue&lt;Runnable&gt; queue = new ArrayBlockingQueue&lt;Runnable&gt;(Math.max(threadCnt*2, 256));<a name="line.129"></a>
<FONT color="green">130</FONT>                    final WorkerThread[] threads = new WorkerThread[threadCnt];<a name="line.130"></a>
<FONT color="green">131</FONT>                    for (int i = 0; i &lt; threadCnt; i++) {<a name="line.131"></a>
<FONT color="green">132</FONT>                            final WorkerThread thread = new WorkerThread(queue, exception);<a name="line.132"></a>
<FONT color="green">133</FONT>                            threads[i] = thread;<a name="line.133"></a>
<FONT color="green">134</FONT>                            thread.start();<a name="line.134"></a>
<FONT color="green">135</FONT>                    }<a name="line.135"></a>
<FONT color="green">136</FONT>                    int index = 0;<a name="line.136"></a>
<FONT color="green">137</FONT>                    for (final Col col : columns) {<a name="line.137"></a>
<FONT color="green">138</FONT>                            index++;<a name="line.138"></a>
<FONT color="green">139</FONT>                            final int curindex = index + offset;<a name="line.139"></a>
<FONT color="green">140</FONT>                            if (curindex % logcnt == 0) {<a name="line.140"></a>
<FONT color="green">141</FONT>                                    if (log != null) log.append(curindex + "...");<a name="line.141"></a>
<FONT color="green">142</FONT>                                    if (curindex % (10*logcnt) == 0) logcnt *= 10;<a name="line.142"></a>
<FONT color="green">143</FONT>                            }<a name="line.143"></a>
<FONT color="green">144</FONT>                            final Runnable runnable = new Runnable() {<a name="line.144"></a>
<FONT color="green">145</FONT>                                    public void run() {<a name="line.145"></a>
<FONT color="green">146</FONT>                                            FluxDistribution dist;<a name="line.146"></a>
<FONT color="green">147</FONT>                                            try {<a name="line.147"></a>
<FONT color="green">148</FONT>                                                    dist = createFluxDistributionFromColumn(log, config, model, col, callback.getGranularity());<a name="line.148"></a>
<FONT color="green">149</FONT>                                            }<a name="line.149"></a>
<FONT color="green">150</FONT>                                            catch (CannotReconstructFluxException ex) {<a name="line.150"></a>
<FONT color="green">151</FONT>                                                    //log already ended at createFluxDistributionFromColumn()<a name="line.151"></a>
<FONT color="green">152</FONT>    //                                              LOG.warning(ex + " at mode " + curindex + " of " + efmCount);<a name="line.152"></a>
<FONT color="green">153</FONT>    //                                              LOG.warning("writing a NaN vector to continue");<a name="line.153"></a>
<FONT color="green">154</FONT>    //                                              double[] vals = new double[col.totalSize()];<a name="line.154"></a>
<FONT color="green">155</FONT>    //                                              Arrays.fill(vals, Double.NaN);<a name="line.155"></a>
<FONT color="green">156</FONT>    //                                              dist = new DefaultFluxDistribution(model.getMetabolicNetwork(), vals);<a name="line.156"></a>
<FONT color="green">157</FONT>    //                                              if (log != null) log.fineStart("... uncompressing ...");<a name="line.157"></a>
<FONT color="green">158</FONT>                                                    throw ex;<a name="line.158"></a>
<FONT color="green">159</FONT>                                            } <a name="line.159"></a>
<FONT color="green">160</FONT>                                            writeFluxDistributionToCallback(model.getMetabolicNetwork(), config, dist, efmCount, callback);<a name="line.160"></a>
<FONT color="green">161</FONT>                                    }<a name="line.161"></a>
<FONT color="green">162</FONT>                            };<a name="line.162"></a>
<FONT color="green">163</FONT>                            try {<a name="line.163"></a>
<FONT color="green">164</FONT>                                    queue.put(runnable);<a name="line.164"></a>
<FONT color="green">165</FONT>                            } <a name="line.165"></a>
<FONT color="green">166</FONT>                            catch (InterruptedException e) {<a name="line.166"></a>
<FONT color="green">167</FONT>                                    throw ExceptionUtil.toIOException(e);<a name="line.167"></a>
<FONT color="green">168</FONT>                            }<a name="line.168"></a>
<FONT color="green">169</FONT>                            if (exception.get() != null) {<a name="line.169"></a>
<FONT color="green">170</FONT>                                    queue.clear();<a name="line.170"></a>
<FONT color="green">171</FONT>                                    break;<a name="line.171"></a>
<FONT color="green">172</FONT>                            }<a name="line.172"></a>
<FONT color="green">173</FONT>                    }                       <a name="line.173"></a>
<FONT color="green">174</FONT>                    for (final WorkerThread thread : threads) {<a name="line.174"></a>
<FONT color="green">175</FONT>                            thread.setEndOfQueue();                 <a name="line.175"></a>
<FONT color="green">176</FONT>                    }<a name="line.176"></a>
<FONT color="green">177</FONT>                    for (final Thread thread : threads) {<a name="line.177"></a>
<FONT color="green">178</FONT>                            try {<a name="line.178"></a>
<FONT color="green">179</FONT>                                    thread.join();<a name="line.179"></a>
<FONT color="green">180</FONT>                            } <a name="line.180"></a>
<FONT color="green">181</FONT>                            catch (InterruptedException e) {<a name="line.181"></a>
<FONT color="green">182</FONT>                                    throw ExceptionUtil.toIOException(e);<a name="line.182"></a>
<FONT color="green">183</FONT>                            }<a name="line.183"></a>
<FONT color="green">184</FONT>                    }<a name="line.184"></a>
<FONT color="green">185</FONT>                    if (log != null &amp;&amp; log.isStarted()) log.end(efmCount + " done.");<a name="line.185"></a>
<FONT color="green">186</FONT>                    if (exception.get() != null) {<a name="line.186"></a>
<FONT color="green">187</FONT>                            throw exception.get();<a name="line.187"></a>
<FONT color="green">188</FONT>                    }<a name="line.188"></a>
<FONT color="green">189</FONT>            }<a name="line.189"></a>
<FONT color="green">190</FONT>            <a name="line.190"></a>
<FONT color="green">191</FONT>            /**<a name="line.191"></a>
<FONT color="green">192</FONT>             * For every external-to-external (e2e) reactions (a reactions which is <a name="line.192"></a>
<FONT color="green">193</FONT>             * uptake and excretion reaction at the same time), we add an EFM. This EFM <a name="line.193"></a>
<FONT color="green">194</FONT>             * has flux value one for the e2e reaction, zero for all other reactions. If <a name="line.194"></a>
<FONT color="green">195</FONT>             * the 2e2 reaction is reversible, another EFM with -1 at this reaction is<a name="line.195"></a>
<FONT color="green">196</FONT>             * added. <a name="line.196"></a>
<FONT color="green">197</FONT>             * <a name="line.197"></a>
<FONT color="green">198</FONT>             * @return the total number of EFMs, including the e2e EFMs already written<a name="line.198"></a>
<FONT color="green">199</FONT>             */<a name="line.199"></a>
<FONT color="green">200</FONT>            protected long writeE2eReactionsToCallback(Config config, NetworkEfmModel model, Iterable&lt;Col&gt; columns, EfmOutputCallback callback) throws IOException {<a name="line.200"></a>
<FONT color="green">201</FONT>                    final MetabolicNetwork metaNet = model.getMetabolicNetwork();<a name="line.201"></a>
<FONT color="green">202</FONT>                    long efmCount = ColumnUtil.getColumnCount(columns);<a name="line.202"></a>
<FONT color="green">203</FONT>                    final NumberOperations&lt;N&gt; numberOps = columnHome.getNumberOperations();<a name="line.203"></a>
<FONT color="green">204</FONT>                    //first, count only<a name="line.204"></a>
<FONT color="green">205</FONT>                    final ArrayIterable&lt;? extends Reaction&gt; reacts = metaNet.getReactions();<a name="line.205"></a>
<FONT color="green">206</FONT>                    for (int ii = 0; ii &lt; reacts.length(); ii++) {<a name="line.206"></a>
<FONT color="green">207</FONT>                            Reaction reac = reacts.get(ii);<a name="line.207"></a>
<FONT color="green">208</FONT>                            if (reac.isUptake() &amp;&amp; reac.isExtract()) {<a name="line.208"></a>
<FONT color="green">209</FONT>                                    efmCount++;<a name="line.209"></a>
<FONT color="green">210</FONT>                                    if (reac.getConstraints().isReversible()) {<a name="line.210"></a>
<FONT color="green">211</FONT>                                            efmCount++;<a name="line.211"></a>
<FONT color="green">212</FONT>                                    }<a name="line.212"></a>
<FONT color="green">213</FONT>                            }<a name="line.213"></a>
<FONT color="green">214</FONT>                    }<a name="line.214"></a>
<FONT color="green">215</FONT>                    //now, create and write to callback<a name="line.215"></a>
<FONT color="green">216</FONT>                    for (int ii = 0; ii &lt; reacts.length(); ii++) {<a name="line.216"></a>
<FONT color="green">217</FONT>                            Reaction reac = reacts.get(ii);<a name="line.217"></a>
<FONT color="green">218</FONT>                            if (reac.isUptake() &amp;&amp; reac.isExtract()) {<a name="line.218"></a>
<FONT color="green">219</FONT>                                    final N[] rates = numberOps.newArray(reacts.length());<a name="line.219"></a>
<FONT color="green">220</FONT>                                    Arrays.fill(rates, numberOps.zero());<a name="line.220"></a>
<FONT color="green">221</FONT>                                    rates[ii] = numberOps.one();<a name="line.221"></a>
<FONT color="green">222</FONT>                                    writeFluxDistributionToCallback(metaNet, config, columnHome.createFluxDistribution(metaNet, rates), efmCount, callback);<a name="line.222"></a>
<FONT color="green">223</FONT>                                    if (reac.getConstraints().isReversible()) {<a name="line.223"></a>
<FONT color="green">224</FONT>                                            final N[] ratesRev = rates.clone();<a name="line.224"></a>
<FONT color="green">225</FONT>                                            ratesRev[ii] = numberOps.negate(numberOps.one());<a name="line.225"></a>
<FONT color="green">226</FONT>                                            writeFluxDistributionToCallback(metaNet, config, columnHome.createFluxDistribution(metaNet, ratesRev), efmCount, callback);<a name="line.226"></a>
<FONT color="green">227</FONT>                                    }<a name="line.227"></a>
<FONT color="green">228</FONT>                            }<a name="line.228"></a>
<FONT color="green">229</FONT>                    }<a name="line.229"></a>
<FONT color="green">230</FONT>                    return efmCount;<a name="line.230"></a>
<FONT color="green">231</FONT>            }<a name="line.231"></a>
<FONT color="green">232</FONT>            <a name="line.232"></a>
<FONT color="green">233</FONT>            /**<a name="line.233"></a>
<FONT color="green">234</FONT>             * Uncompresses the flux distribution, normalizes it (if necessary) and <a name="line.234"></a>
<FONT color="green">235</FONT>             * writes it to the given callback. Note that this method is called from<a name="line.235"></a>
<FONT color="green">236</FONT>             * multiple threads, thus, the actual call to the <a name="line.236"></a>
<FONT color="green">237</FONT>             * {@link EfmOutputCallback callback} is synchronized.<a name="line.237"></a>
<FONT color="green">238</FONT>             */<a name="line.238"></a>
<FONT color="green">239</FONT>            protected void writeFluxDistributionToCallback(final MetabolicNetwork metaNet, Config config, FluxDistribution dist, long efmCount, EfmOutputCallback callback) {               <a name="line.239"></a>
<FONT color="green">240</FONT>                    boolean doNormalize = true;<a name="line.240"></a>
<FONT color="green">241</FONT>                    if (callback.getGranularity().isUncompressionNeeded() &amp;&amp; metaNet instanceof CompressedMetabolicNetwork) {<a name="line.241"></a>
<FONT color="green">242</FONT>                            dist = ((CompressedMetabolicNetwork)metaNet).uncompressFluxDistribution(dist);<a name="line.242"></a>
<FONT color="green">243</FONT>                            <a name="line.243"></a>
<FONT color="green">244</FONT>                            if (callback.getGranularity() == CallbackGranularity.BinaryUncompressed || callback.getGranularity() == CallbackGranularity.SignUncompressed) {<a name="line.244"></a>
<FONT color="green">245</FONT>                                    //renormalize the flux values to 0/1/-1<a name="line.245"></a>
<FONT color="green">246</FONT>                                    for (int i = 0; i &lt; dist.getSize(); i++) {<a name="line.246"></a>
<FONT color="green">247</FONT>                                            dist.setRate(i, Integer.valueOf(dist.getRateSignum(i)));<a name="line.247"></a>
<FONT color="green">248</FONT>                                    }<a name="line.248"></a>
<FONT color="green">249</FONT>                                    doNormalize = false;<a name="line.249"></a>
<FONT color="green">250</FONT>                            }<a name="line.250"></a>
<FONT color="green">251</FONT>                    }<a name="line.251"></a>
<FONT color="green">252</FONT>                    if (doNormalize) {<a name="line.252"></a>
<FONT color="green">253</FONT>                            dist.norm(config.getNormalize().norm, config.zero());<a name="line.253"></a>
<FONT color="green">254</FONT>                    }<a name="line.254"></a>
<FONT color="green">255</FONT>                    if (callback.isThreadSafe()) {<a name="line.255"></a>
<FONT color="green">256</FONT>                            callback.callback(new EfmOutputEvent(metaNet, dist, efmCount));<a name="line.256"></a>
<FONT color="green">257</FONT>                    }<a name="line.257"></a>
<FONT color="green">258</FONT>                    else {<a name="line.258"></a>
<FONT color="green">259</FONT>                            synchronized(callback) {<a name="line.259"></a>
<FONT color="green">260</FONT>                                    callback.callback(new EfmOutputEvent(metaNet, dist, efmCount));<a name="line.260"></a>
<FONT color="green">261</FONT>                            }<a name="line.261"></a>
<FONT color="green">262</FONT>                    }<a name="line.262"></a>
<FONT color="green">263</FONT>            }<a name="line.263"></a>
<FONT color="green">264</FONT>    <a name="line.264"></a>
<FONT color="green">265</FONT>            /**<a name="line.265"></a>
<FONT color="green">266</FONT>             * Creates a numeric flux distribution from a binary column. The nullspace<a name="line.266"></a>
<FONT color="green">267</FONT>             * is computed to do so. Furthermore, duplicated reversible reactions are<a name="line.267"></a>
<FONT color="green">268</FONT>             * compressed again.<a name="line.268"></a>
<FONT color="green">269</FONT>             * &lt;p&gt;<a name="line.269"></a>
<FONT color="green">270</FONT>             * Deletages to {@link #createFluxDistributionFromColumn(LogFragmenter, Config, NetworkEfmModel, Column, CallbackGranularity)}<a name="line.270"></a>
<FONT color="green">271</FONT>             * with &lt;code&gt;null&lt;/code&gt; as log fragmenter.<a name="line.271"></a>
<FONT color="green">272</FONT>             */<a name="line.272"></a>
<FONT color="green">273</FONT>            public FluxDistribution createFluxDistributionFromColumn(Config config, NetworkEfmModel model, Col column) {<a name="line.273"></a>
<FONT color="green">274</FONT>                    return createFluxDistributionFromColumn(null, config, model, column, CallbackGranularity.DoubleUncompressed);<a name="line.274"></a>
<FONT color="green">275</FONT>            }<a name="line.275"></a>
<FONT color="green">276</FONT>    <a name="line.276"></a>
<FONT color="green">277</FONT>            abstract protected FluxDistribution createFluxDistributionFromColumn(LogFragmenter log, Config config, NetworkEfmModel model, Col column, CallbackGranularity granularity);<a name="line.277"></a>
<FONT color="green">278</FONT>    <a name="line.278"></a>
<FONT color="green">279</FONT>    }<a name="line.279"></a>




























































</PRE>
</BODY>
</HTML>
